| OpenCV 3.4.1 Open Source Computer Vision

Public Member Functions | Public Attributes | List of all members
cv::line_descriptor::KeyLine Struct Reference
Binary descriptors for lines extracted from an image

A class to represent a line. More...

`#include "descriptor.hpp"`

## Public Member Functions
| KeyLine ()
Point2f | getEndPoint () const
Point2f | getEndPointInOctave () const
Point2f | getStartPoint () const
Point2f | getStartPointInOctave () const

## Public Attributes
float | angle
int | class_id
float | endPointX
float | endPointY
float | ePointInOctaveX
float | ePointInOctaveY
float | lineLength
int | numOfPixels
int | octave
Point2f | pt
float | response
float | size
float | sPointInOctaveX
float | sPointInOctaveY
float | startPointX
float | startPointY

## Detailed Description

A class to represent a line.

As aformentioned, it is been necessary to design a class that fully stores the information needed to characterize completely a line and plot it on image it was extracted from, when required.

KeyLine* class has been created for such goal; it is mainly inspired to Feature2d's KeyPoint class, since KeyLine shares some of KeyPoint's fields, even if a part of them assumes a different meaning, when speaking about lines. In particular:

- the class_id field is used to gather lines extracted from different octaves which refer to same line inside original image (such lines and the one they represent in original image share the same class_id value)
- the angle field represents line's slope with respect to (positive) X axis
- the pt field represents line's midpoint
- the response field is computed as the ratio between the line's length and maximum between image's width and height
- the size field is the area of the smallest rectangle containing line

Apart from fields inspired to KeyPoint class, KeyLines stores information about extremes of line in original image and in octave it was extracted from, about line's length and number of pixels it covers.

## Constructor & Destructor Documentation

## § KeyLine()

cv::line_descriptor::KeyLine::KeyLine | ( |  | ) |
| inline

constructor

## Member Function Documentation

## § getEndPoint()

Point2f cv::line_descriptor::KeyLine::getEndPoint | ( |  | ) | const
| inline

Returns the end point of the line in the original image

## § getEndPointInOctave()

Point2f cv::line_descriptor::KeyLine::getEndPointInOctave | ( |  | ) | const
| inline

Returns the end point of the line in the octave it was extracted from

## § getStartPoint()

Point2f cv::line_descriptor::KeyLine::getStartPoint | ( |  | ) | const
| inline

Returns the start point of the line in the original image

## § getStartPointInOctave()

Point2f cv::line_descriptor::KeyLine::getStartPointInOctave | ( |  | ) | const
| inline

Returns the start point of the line in the octave it was extracted from

## Member Data Documentation

## § angle

float cv::line_descriptor::KeyLine::angle

orientation of the line

## § class_id

int cv::line_descriptor::KeyLine::class_id

object ID, that can be used to cluster keylines by the line they represent

## § endPointX

float cv::line_descriptor::KeyLine::endPointX

## § endPointY

float cv::line_descriptor::KeyLine::endPointY

## § ePointInOctaveX

float cv::line_descriptor::KeyLine::ePointInOctaveX

## § ePointInOctaveY

float cv::line_descriptor::KeyLine::ePointInOctaveY

## § lineLength

float cv::line_descriptor::KeyLine::lineLength

the length of line

## § numOfPixels

int cv::line_descriptor::KeyLine::numOfPixels

number of pixels covered by the line

## § octave

int cv::line_descriptor::KeyLine::octave

octave (pyramid layer), from which the keyline has been extracted

## § pt

Point2f cv::line_descriptor::KeyLine::pt

coordinates of the middlepoint

## § response

float cv::line_descriptor::KeyLine::response

the response, by which the strongest keylines have been selected. It's represented by the ratio between line's length and maximum between image's width and height

## § size

float cv::line_descriptor::KeyLine::size

minimum area containing line

## § sPointInOctaveX

float cv::line_descriptor::KeyLine::sPointInOctaveX

line's extremes in image it was extracted from

## § sPointInOctaveY

float cv::line_descriptor::KeyLine::sPointInOctaveY

## § startPointX

float cv::line_descriptor::KeyLine::startPointX

lines's extremes in original image

## § startPointY

float cv::line_descriptor::KeyLine::startPointY

The documentation for this struct was generated from the following file:

- /build/master-contrib_docs-lin64/opencv_contrib/modules/line_descriptor/include/opencv2/line_descriptor/descriptor.hpp